import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class Destroyer here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Destroyer  extends Actor
{
    /**
     * Act - do whatever the Destroyer wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        move();
        checkCollision();
    }

    private void move()
    {
        if (Greenfoot.isKeyDown("left"))
        {
            moveLeft();
            rotateLeft();
        }
        
        if (Greenfoot.isKeyDown("right"))
        {
            moveRight();
            rotateRight();
        }
        
        if (Greenfoot.isKeyDown("up"))
        {    
            moveUp();
            rotateLeft();
        }
            
        if (Greenfoot.isKeyDown("down"))
        {
            moveDown();       
            rotateRight();
        }
    }

    private void rotateRight()
    {
        int rot = getRotation() + 8;
        if(rot == 360) {
            rot = 0;
        }       
        setRotation(rot);
    }
    
    private void rotateLeft()
    {
        int rot = getRotation() - 8;
        if(rot == -360) {
            rot = 0;
        }       
        setRotation(rot);
    }
    
    private void moveLeft()
    {
        setLocation(getX() - 3, getY());
    }


    private void moveRight()
    {
        setLocation(getX() + 3, getY());
    }


    private void moveUp()
    {
        setLocation(getX(), getY() - 3);
    }


    private void moveDown()
    {
        setLocation(getX(), getY() + 3);
    }


    private void checkCollision()
    {
        C c = (C)getOneIntersectingObject (C.class);
        Cs cs = (Cs)getOneIntersectingObject (Cs.class);
        D d = (D)getOneIntersectingObject (D.class);
        Ds ds = (Ds)getOneIntersectingObject (Ds.class);
        E e = (E)getOneIntersectingObject (E.class);
        F f = (F)getOneIntersectingObject (F.class);
        Fs fs = (Fs)getOneIntersectingObject (Fs.class);
        G g = (G)getOneIntersectingObject (G.class);
        Gs gs = (Gs)getOneIntersectingObject (Gs.class);
        A a = (A)getOneIntersectingObject (A.class);
        As as = (As)getOneIntersectingObject (As.class);
        B b = (B)getOneIntersectingObject (B.class);
        Red red = (Red)getOneIntersectingObject (Red.class);

        if (red != null)
            ((MyWorld) getWorld()).gameOver();
        if (c != null)
        {    
            c.destroy();
            ((MyWorld) getWorld()).addScore();
        }
        else if (cs != null)
        {    
            cs.destroy();
            ((MyWorld) getWorld()).addScore();
        }
        else if (d != null)
        {
            d.destroy();
            ((MyWorld) getWorld()).addScore();
        }
        else if (ds != null)
        {
            ds.destroy();
            ((MyWorld) getWorld()).addScore();
        }
        else if (e != null)
        {
            e.destroy();
            ((MyWorld) getWorld()).addScore();
        }
        else if (f != null)
        { 
            f.destroy();
            ((MyWorld) getWorld()).addScore();
        }
        else if (fs != null)
        {
            fs.destroy();
            ((MyWorld) getWorld()).addScore();
        }
        else if (g != null)
        { 
            g.destroy();
            ((MyWorld) getWorld()).addScore();
        }
        else if (gs != null)
        {
            gs.destroy();
            ((MyWorld) getWorld()).addScore();
        }
        else if (a != null)
        {    
            a.destroy();
            ((MyWorld) getWorld()).addScore();
        }
        else if (as != null)
        {    
            as.destroy();
            ((MyWorld) getWorld()).addScore();
        }
        else if (b!= null)
        {
            b.destroy();
            ((MyWorld) getWorld()).addScore();
        }
            
    }
}
