import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class MyWorld here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class MyWorld  extends World
{
    private int random, numberX, numberY;
    
    Destroyer destroy = new Destroyer();
    Counter counter = new Counter("Score: ");
    
    GreenfootSound end = new GreenfootSound ("end.wav"); 
    GreenfootSound endwin = new GreenfootSound ("endwin.wav"); 
    /**
     * Constructor for objects of class MyWorld.
     * 
     */
    public MyWorld()
    {    
        // Create a new world with 600x400 cells with a cell size of 1x1 pixels.
        super(600, 400, 1); 
        addObject(destroy, 300, 200);
        addObject(counter, 100, 375);
        setPaintOrder(ScoreBoard.class, Destroyer.class, Counter.class);
    }

    public void act()
    {
        if (checkPro() == false)
            spawn();
        else 
            spawnPro();
            
        win();
    }

    private void spawn()
    {
        random = Greenfoot.getRandomNumber(7);
        if (Greenfoot.getRandomNumber(110) == 15)
        {
            if (random == 0)
                addObject(new C(), getRandomX(), getRandomY());
            else if (random == 1)
                addObject(new D(), getRandomX(), getRandomY());
            else if (random == 2)
                addObject(new E(), getRandomX(), getRandomY());
            else if (random == 3)
                addObject(new F(), getRandomX(), getRandomY());
            else if (random == 4)
                addObject(new G(), getRandomX(), getRandomY());
            else if (random == 5)
                addObject(new A(), getRandomX(), getRandomY());
            else if (random == 6)
                addObject(new B(), getRandomX(), getRandomY());
        }
        if (Greenfoot.getRandomNumber(400) == 1)
            addObject(new Red(), getRandomX(), getRandomY());
    }

    private void spawnPro()
    {
        random = Greenfoot.getRandomNumber(11);
        if (Greenfoot.getRandomNumber(100) == 15)
        {
            if (random == 0)
                addObject(new C(), getRandomX(), getRandomY());
            else if (random == 1)
                addObject(new C(), getRandomX(), getRandomY());
            else if (random == 2)
                addObject(new E(), getRandomX(), getRandomY()); 
            else if (random == 3)
                addObject(new F(), getRandomX(), getRandomY());  
            else if (random == 4)
                addObject(new G(), getRandomX(), getRandomY());
            else if (random == 5)
                addObject(new A(), getRandomX(), getRandomY());
            else if (random == 6)
                addObject(new B(), getRandomX(), getRandomY());
            else if (random == 7)
                addObject(new Cs(), getRandomX(), getRandomY());
            else if (random == 8)
                addObject(new Ds(), getRandomX(), getRandomY());
            else if (random == 9)
                addObject(new Fs(), getRandomX(), getRandomY());
            else if (random == 10)
                addObject(new Gs(), getRandomX(), getRandomY());
            else if (random == 11)
                addObject(new As(), getRandomX(), getRandomY());
        }
        if (Greenfoot.getRandomNumber(450) == 1)
            addObject(new Red(), getRandomX(), getRandomY());
    }
    
    private boolean checkPro()
    {   
        if (getValue() < 150)
            return false;
        else 
            return true;
    }
    
    private int getRandomY()
    {
        numberY = Greenfoot.getRandomNumber(260) + 70;
        return numberY;
    }
    
    private int getRandomX()
    {
        numberX = Greenfoot.getRandomNumber(460) + 70;
        return numberX;
    }

    public void addScore()
    {
        counter.add(10);
    }
    
    public int getValue()
    { 
        //gets score
        return counter.getValue();
    }
    
    public void gameOver()
    {
        //stops game
        Greenfoot.stop();
        //plays epic end song
        end.play();
        //make and display a scoreboard
        ScoreBoard s = new ScoreBoard(getValue());
        addObject(s,320,200);
    }

    public void win()
    {
        //if player got the right note ___ times, win
        if (getValue() == 350)
        {
            //stops game
            Greenfoot.stop();
            //plays epic end song, with claps
            endwin.play();
            //make and display a scoreboard
            ScoreBoard s = new ScoreBoard(getValue(), "You Win!");
            addObject(s,320,200);
        }
    }
}
